require 'gun_test/shell'
require 'gun_test/shot'

module GunTest
  class Gun
    include Shell
    attr_reader :name

    def initialize(name)
      @name = name
    end

    def reload(ammo)
      # Only C++ supported by now!
      task "Reloading gun..." do
        say_status "Reloading".blue
        reloaded = system("g++ #{ammo} -O2 -o #{name} 2> /dev/null")

        say_status reloaded ? "Done".green : "Failed".red

        reloaded
      end
    end

    def shoot(target_number = 50, &block)
      target_number.times do |i|
        break false unless task "Shot #{i+1}" do
          say_status "Reloading bullet...".blue

          shot = Shot.new
          shot.instance_exec(i, &block)

          say_status "Shooting!".blue
          headshot = shot.bang!(name)

          say_status headshot ? "Headshot!".green : "Failed".red

          headshot
        end
      end
    end
  end
end
