module GunTest
  module Shell
    class Task
      PADDING = 5

      def initialize(description)
        @description = description
        @status_length = 0
      end

      def perform(&block)
        @self_before_instance_eval = eval "self", block.binding
        instance_eval &block
      end

      def method_missing(method, *args, &block)
        @self_before_instance_eval.send method, *args, &block
      end

      def say_status(status)
        print "\r" unless @status_length == 0

        status = " " * PADDING + @description.ljust(PADDING * 5) + status
        print status.ljust(@status_length)

        @status_length = status.length
      end
    end
  end
end
